      real*8 function alphasPDF(Q)
      implicit none
      real*8 Q,a
*
      call evolveAs(Q,a)
      alphasPDF=a
      return
*
      end
*
      subroutine evolveAs(Q,alphas)
      implicit none
      character*16 s1,s2,s3
      real*8 Q,Q0,alphas,alfas0,alfasQ,scale0,Mc,Mb,Mt
      real*8 b0,b1,b2,L,As,alphasPDF,mass
      parameter (b0=1.2202,b1=0.4897,b2=0.1913)
      integer order,EvlOrd,parm,Etype,Method,nf,n
      real*8 Massc,Massb,Masst
      common/masses/Massc,Massb,Masst
      save EvlOrd,parm,Etype,alfasQ,Q0,Method,Mc,Mb,Mt
      equivalence (Mc,Massc)
      equivalence (Mb,Massb)
      equivalence (Mt,Masst)
*
      if (method.eq.0) then
         if ((Etype.eq.1).or.(Etype.eq.2)) then
            L=log(Q/Q0)
            As=alfasQ
            if (Etype.eq.2) call GetParmPDF(parm,As)
            if (EvlOrd.eq.0) L=b0*L
            if (EvlOrd.eq.1) L=(b0+As*b1)*L
            if (EvlOrd.eq.2) L=(b0+As*b1+As**2*b2)*L
     .                        -0.5*As**2*b0*b1/2d0*L**2
            alphas=As/(1.0+As*L)
         endif
      endif
      if (method.eq.1) then
         call alfasevolve(alphas,Q)
      endif
      if (method.eq.2) then
         call alphamrs(alphas,Q)
      endif
      return
*
      entry GetQmass(nf,mass)
      n=abs(nf)
      mass=0d0
      if (n.eq.4) mass=Mc
      if (n.eq.5) mass=Mb
      if (n.eq.6) mass=Mt
      return

      entry GetAlfas(alfas0,scale0)
      scale0=Q0
      alfas0=alfasQ
      if (Etype.eq.2) call GetParmPDF(parm,alfas0)
      return
*
      entry GetOrderAs(order)
      order=EvlOrd
      return
*
      entry InitAlphasPDF
      Etype=-1
      EvlOrd=-1
      read(1,*) s1,s2,s3
      if (index(s2,'lo').eq.1) EvlOrd=0
      if (index(s2,'nlo').eq.1) EvlOrd=1
      if (index(s2,'nnlo').eq.1) EvlOrd=2
      if (EvlOrd.lt.0) then
         write(*,*) 'File description error:'
         write(*,*) 'Unknown alpha_s evolution order ',s2
         stop
      endif
      if (index(s1,'Fixed').eq.1) then
         Etype=1
         parm=-1
         read(1,*) alfasQ,Q0,Mc,Mb,Mt
      endif
      if (index(s1,'Variable').eq.1) then
         Etype=2
         alfasQ=0d0
         read(1,*) parm,Q0,Mc,Mb,Mt
      endif
      if (Etype.lt.0) then
         write(*,*) 'File description error:'
         write(*,*) 'Unknown alpha_S evolution method ',s1
         stop
      endif
      Method=-1
      if (index(s3,'Internal').eq.1) Method=0
      if (index(s3,'EvolCode').eq.1) Method=1
      if (index(s3,'MRSTalfa').eq.1) Method=2
      if (Method.lt.0) then
         write(*,*) 'File description error:'
         write(*,*) 'Unknown alpha_S method ',s3
         stop
      endif
      return
      end
*
 
      subroutine alphamrs(alpha,Q)
      IMPLICIT real*8 (a-h,o-z)
      common/SET/iset
      common/masses/cMass,bMass,tMass
      dimension parms(30)
      DATA PI/3.14159/
      DATA TOL/.0005/
      data ifirst/0/
      save alambda
c
c      alambda=0.323
c      alambda=0.3342
c -- find alambda corresponding to alphas given in first parameter
      if(ifirst.eq.0) then
        call listPDF(iset,parms)
	alphas = parms(1)
        ifirst=1 
        qz2=8315.
        qz = dsqrt(qz2)
        alambda = 0.3000
        astep = 0.010
        tol2 = 0.0000001
        idir = +1
  10    continue
        alambda = alambda + idir*astep
        call mrslambda(alpha,qz,alambda)
          if(idir*(alphas-alpha).gt.0.0) then
             go to 20
          else
             astep = 0.5*astep
	     idir = -1*idir
	     go to 20
          endif	 
  20   continue
        if(abs(alpha-alphas).gt.tol2) go to 10
      endif
c - alambda found  -- save it !!!!
c - next call mrslambda to get alphas at q with the correct alambda
    
      call mrslambda(alpha,q,alambda)
      RETURN
      END
*
      subroutine rgras(alpha,Q2)
      IMPLICIT real*8 (a-h,o-z)
      q=dsqrt(q2)
      call alphamrs(alpha,Q)
      return
      end
*
* new vewrsion of mrslambda 13/5/2004 - includes lo, nlo, and nnlo with flags
*
      subroutine mrslambda(alpha,Q,alambda)
      IMPLICIT REAL*8(A-H,O-Z)
      DATA PI/3.14159/
      DATA TOL/.0005/
c  The value of Lambda required corresponds to nflav=4
c  iord=0 gives leading order, iord=1 gives NLO, iord=2 gives NNLO
      qsdt=8.18    !!  This is the value of 4m_c^2
      qsct=74.0    !!  This is the value of 4m_b^2
      al2=alambda*alambda
      q2=q*q
      t=dlog(q2/al2)
c
c next line to be replaced by a getiord in the final version
c      iord=1
c
      call GetOrderAs(iord)
      ITH=0
      TT=T
      qsdtt=qsdt/4.
      qsctt=qsct/4.
      AL=ALAMBDA
      AL2=AL*AL
      FLAV=4.
      QS=AL2*dEXP(T)

      if(qs.lt.0.5d0) then   !!  running stops below 0.5
          qs=0.5d0
          t=dlog(qs/al2)
          tt=t
      endif

      IF(QS.gt.QSCTT) GO	TO 12  
      IF(QS.lt.QSDTT) GO	TO 312  
   11 CONTINUE
      B0=11-2.*FLAV/3. 
      X1=4.*PI/B0
      IF(IORD.eq.0) then
      ALPHA=X1/T
      ELSE
          if(iord.gt.1) then
          alpha=qwikalf(t,iord,flav)
          go to 51
          endif 
      B1=102.-38.*FLAV/3.
      X2=B1/B0**2
      AS2=X1/T*(1.-X2*dLOG(T)/T)
    5 AS=AS2
      F=-T+X1/AS-X2*dLOG(X1/AS+X2)
      FP=-X1/AS**2*(1.-X2/(X1/AS+X2))
      AS2=AS-F/FP
      DEL=ABS(F/FP/AS)
      IF((DEL-TOL).GT.0.) go to 5
      ALPHA=AS2
   51 continue
      ENDIF
      IF(ITH.EQ.0) RETURN
      GO TO (13,14,15) ITH
c      GO TO 5
   12 ITH=1
      T=dLOG(QSCTT/AL2)
      GO TO 11
   13 ALFQC4=ALPHA
      FLAV=5.   
      ITH=2

      GO TO 11
   14 ALFQC5=ALPHA
      ITH=3
      T=TT
      GO TO 11
   15 ALFQS5=ALPHA
      ALFINV=1./ALFQS5+1./ALFQC4-1./ALFQC5
      ALPHA=1./ALFINV
      RETURN

  311 CONTINUE
      B0=11-2.*FLAV/3. 
      X1=4.*PI/B0
      IF(IORD.eq.0) then
      ALPHA=X1/T

      ELSE
          if(iord.gt.1) then
          alpha=qwikalf(t,iord,flav)
          go to 351
          endif 
      B1=102.-38.*FLAV/3.
      X2=B1/B0**2
      AS2=X1/T*(1.-X2*dLOG(T)/T)
   35 AS=AS2
      F=-T+X1/AS-X2*dLOG(X1/AS+X2)
      FP=-X1/AS**2*(1.-X2/(X1/AS+X2))
      AS2=AS-F/FP
      DEL=ABS(F/FP/AS)
      IF((DEL-TOL).GT.0.) go to 35
      ALPHA=AS2

  351 continue
      endif
      IF(ITH.EQ.0) RETURN
      GO TO (313,314,315) ITH
  312 ITH=1
      T=dLOG(QSDTT/AL2)
      GO TO 311
  313 ALFQC4=ALPHA
      FLAV=3.   
      ITH=2
      GO TO 311
  314 ALFQC3=ALPHA
      ITH=3
      T=TT
      GO TO 311
  315 ALFQS3=ALPHA
      ALFINV=1./ALFQS3+1./ALFQC4-1./ALFQC3
      ALPHA=1./ALFINV
      RETURN
      END


      double precision function qwikalf(t,iord,flav)
      implicit real*8(a-h,o-z)
      dimension z3(6),z4(6),z5(6),zz3(6),zz4(6),zz5(6)
      data z3/ -.161667E+01,0.954244E+01,
     .0.768623E+01,0.101523E+00,-.360127E-02,0.457867E-04/
      data z4/ -.172239E+01,0.831185E+01,
     .0.721463E+01,0.835531E-01,-.285436E-02,0.349129E-04/
      data z5/ -.872190E+00,0.572816E+01,
     .0.716119E+01,0.195884E-01,-.300199E-03,0.151741E-05/
      data zz3/-.155611E+02,0.168406E+02,
     .0.603014E+01,0.257682E+00,-.970217E-02,0.127628E-03/
      data zz4/-.106762E+02,0.118497E+02,0.664964E+01,
     .0.112996E+00,-.317551E-02,0.302434E-04/
      data zz5/-.531860E+01,0.708503E+01,0.698352E+01,
     .0.274170E-01,-.426894E-03,0.217591E-05/

      data pi/3.14159/
      nfm2=flav-2.
      x=dsqrt(t)
      x2=x*x
      x3=x*x2
      x4=x*x3
      x5=x*x4
      go to (1,2) iord
    1 go to (3,4,5) nfm2
    3 y=z3(1)+z3(2)*x+z3(3)*x2+z3(4)*x3+z3(5)*x4+z3(6)*x5
      go to 10
    4 y=z4(1)+z4(2)*x+z4(3)*x2+z4(4)*x3+z4(5)*x4+z4(6)*x5
      go to 10
    5 y=z5(1)+z5(2)*x+z5(3)*x2+z5(4)*x3+z5(5)*x4+z5(6)*x5
      go to 10
    2 go to (6,7,8) nfm2
    6 y=zz3(1)+zz3(2)*x+zz3(3)*x2+zz3(4)*x3+zz3(5)*x4+zz3(6)*x5
      go to 10
    7 y=zz4(1)+zz4(2)*x+zz4(3)*x2+zz4(4)*x3+zz4(5)*x4+zz4(6)*x5
      go to 10
    8 y=zz5(1)+zz5(2)*x+zz5(3)*x2+zz5(4)*x3+zz5(5)*x4+zz5(6)*x5
      go to 10
   10 qwikalf=4.*pi/y
      return
      end


